<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.4
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Shop_admin_category
 *
 * Редактирование категорий магазина
 */
class Shop_admin_category extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file = 'shopcategory';

	/**
	 * @var string таблица в базе данных
	 */
	public $table = 'shop_category';

	/**
	 * Конструктор класса
	 *
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;

		$this->nastr = 100;

		//поля в базе данных для редактирования
		$this->variable_table = array(
			'name'        => 'text',
			'act'         => 'checkbox',
			'menu'        => 'module',
			'images'      => 'module',
			'comments'    => 'module',
			'hr1'         => 'hr',
			'number'      => 'function',
			'timeedit'    => 'text',
			'title_meta'  => 'text',
			'keywords'    => 'text',
			'descr'       => 'textarea',
			'rewrite'     => 'function',
			'parent_id'   => 'select',
			'site_id'     => 'function',
			'sort'        => 'function',
			'show_yandex' => 'checkbox',
			'map_no_show' => 'checkbox',
			'hr2'         => 'hr',
			'anons'       => 'editor',
			'text'        => 'editor',
			'special'     => 'editor'
		);

		//поля, которые прячутся в Дополнительно
		$this->variable_other = array(
			'hr1'         => 1,
			'number'      => 1,
			'title_meta'  => 1,
			'timeedit'    => 1,
			'keywords'    => 1,
			'descr'       => 1,
			'rewrite'     => 1,
			'parent_id'   => 1,
			'site_id'     => 1,
			'sort'        => 1,
			'show_yandex' => 1,
			'map_no_show' => 1
		);

		//переводимые поля
		$this->language_names = array(
			'name',
			'title_meta',
			'act',
			'keywords',
			'special',
			'descr',
			'anons',
			'text'
		);

		$this->config_module = array(
			'parent'       => 1, //содержит вложенности
			'order'        => 1, //сортируется
			'menu'         => 1, //используется в меню
			'act'          => 1, //показать/скрыть
			'del'          => 1, //удалить
			'category'     => 1, //часть модуля - категории
			'category_rel' => 1, //работают вместе с таблицей {module_category_rel}
			'element_site' => 1, //модуль может быть прикреплен к нескольким страницам
			'trash'        => 1  //использовать корзину
		);

		if(! $this->diafan->configmodules('show_yandex_category', 'shop'))
		{
			unset($this->variable_table["show_yandex"]);
		}

		if(! extension_loaded('gd') && ! extension_loaded('gd2'))
		{
			$this->diafan->error = 7;
		}

		//высота поля для Визуального редактора
		$this->editor_height = array(
			'anons' => 200,
			'text'  => 400,
			'special' => 200
		);
	}

	/**
	 * Выводит список категорий
	 * @return boolean true
	 */
	public function show_module()
	{
		$this->addnew_init(_ADMIN_ADD_CATEGORY);
		echo '<table class="list">';
		$this->list_row();
		echo '</table>';

		return TRUE;
	}

	/**
	 * Сопутствующие действия при удалении элемента модуля
	 * @return boolean true
	 */
	protected function delete($del_id, $trash_id)
	{
		$this->del_or_trash_where("shop_param_category_rel", "cat_id=".$del_id, $trash_id);
		$this->del_or_trash_where("shop_discount_object",    "cat_id=".$del_id, $trash_id);

		return TRUE;
	}
}